	.data
        .align 2
result: .space 4

	.text
        .globl main
main:   
	subu    $sp, $sp, 32            # 32-byte stack frame
        sw      $ra, 20($sp)            # save return address
        sw      $fp, 16($sp)            # save old frame pointer
        addu    $fp, $sp, 32            # set new frame pointer
        
        li      $v0, 5                  # system call to read an integer
        syscall

        beq     $v0, $0, exit           # check if integer > 0


        move    $a0, $v0                # $v0 keeps the input value
        jal     fact                    # call fact(), ra <- next PC
	
					# fact runs here

	la      $t5, result             # result is stored in $v0
        sw      $v0, 0($t5)             # store the value into memory


        la      $t5, result             # system call to print_int
	lw	$a0, 0($t5)
        li      $v0, 1                  # call print_int
        syscall
                                            
exit:   
	lw      $ra, 20($sp)            # restore return address
        lw      $fp, 16($sp)            # restore frame pointer
        addu    $sp, $sp, 32            # adjust stack pointer
        jr      $ra                     # return to caller 'main'

######################################################################
	
fact:   
        subu    $sp, $sp, 32            # 32-byte stack frame
        sw      $ra, 20($sp)            # save return address
        sw      $fp, 16($sp)            # save frame pointer
        addu    $fp, $sp, 32            # set up a new frame pointer    
        sw      $a0, 0($fp)             # get argument from $a0 and save it in the frame

        lw      $v0, 0($fp)             # read fact(n) function argument n
        bgtz    $v0, loop2              # branch if n > 0
        li      $v0, 1                  # return 0 if n = 0
        j       loop1			# goto the code that returns

loop2:  lw      $v1, 0($fp)             # read fact(n) function argument n
        subu    $v0, $v1, 1             # n <- n-1
        move    $a0, $2      		# move value to $a0   
        jal     fact			# call fact recursively

        lw      $v1, 0($fp)             # load n to $v1
        mul     $v0, $v0, $v1           # compute fact(n-1)*n and save it in $v0

loop1:  lw      $ra, 20($sp)		# restore $ra to jump
        lw      $fp, 16($sp)		# restore the frame to $fp
        addu    $sp, $sp, 32		# restore the stack to $sp
        jr      $ra			# jump back to the caller

